﻿using System.IO;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.Xml;
using System;

namespace DynamicXamlLoadAndPrint
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Grid dynamicGrid;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var xaml = File.ReadAllText(Environment.CurrentDirectory + "\\Template.xaml");
            using (StringReader stringReader = new StringReader(xaml))
            {
                XmlReader xmlReader = XmlReader.Create(stringReader);
                dynamicGrid = (Grid)XamlReader.Load(xmlReader);
                this.grid.Children.Add(dynamicGrid);
                ReportViewModel reportModel = new ReportViewModel();
                reportModel.Image = "https://myfreetime.cn/usr/uploads/2024/4/%E6%B8%85%E5%B9%B3%E8%B0%83%C2%B7%E5%90%8D%E8%8A%B1%E5%80%BE%E5%9B%BD%E4%B8%A4%E7%9B%B8%E6%AC%A2/jk.jpg";
                reportModel.Text = "HelloWorld";
                reportModel.Width = 300;
                reportModel.Height = 600;
                dynamicGrid.DataContext = reportModel;
            }           
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            PrintDialog pd = new PrintDialog();
            Window window = Window.GetWindow(dynamicGrid);
            Point point = dynamicGrid.TransformToAncestor(window).Transform(new Point(0, 0));//获取当前控件 的坐标
            dynamicGrid.Measure(new Size(dynamicGrid.ActualWidth, dynamicGrid.ActualHeight));
            dynamicGrid.Arrange(new Rect(new Size(dynamicGrid.ActualWidth, dynamicGrid.ActualHeight)));
            pd.PrintVisual(dynamicGrid, "");
            dynamicGrid.Arrange(new Rect(point.X, point.Y, dynamicGrid.ActualWidth, dynamicGrid.ActualHeight));//设置为原来的位置
        }
    }
}