﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace DynamicXamlLoadAndPrint
{
    public class ReportViewModel : INotifyPropertyChanged
    {
        private string image;

        public string Image
        {
            get => this.image;
            set
            {
                this.image = value;
                RaiseChanged("Image");
            }
        }

        private string text;
        public string Text
        {
            get => this.text;
            set
            {
                this.text = value;
                RaiseChanged("Text");
            }
        }

        private int width;
        public int Width
        {
            get => this.width;
            set
            {
                this.width = value;
                RaiseChanged("Width");
            }
        }

        private int height;
        public int Height
        {
            get => this.height;
            set
            {
                this.height = value;
                RaiseChanged("Height");
            }
        }

        public event PropertyChangedEventHandler? PropertyChanged;

        private void RaiseChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
